package model;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import com.google.gson.Gson;

public class MessageMod {
	
	public ArrayList<Message> getMessages(String sendr, String receivr, int offset, int limit) throws SQLException {
		
		ArrayList<Message> list = new ArrayList<Message>();
		Connection con = new DbConnection().getConnection();
   
		PreparedStatement ps = con.prepareStatement("SELECT * FROM message WHERE (sender = ? AND receiver = ?) OR (sender = ? AND receiver = ?) LIMIT ? OFFSET ?");
		ps.setString(1, sendr);
		ps.setString(2, receivr);
		ps.setString(3, receivr);
		ps.setString(4, sendr);
		ps.setInt(5, limit);
		ps.setInt(6, offset);
		ResultSet rs = ps.executeQuery();
		Message cm = null;
		
		while (rs.next()) {
			String id = rs.getString(1);
			String sender = rs.getString(2);
			String receiver = rs.getString(3);
			String content = rs.getString(4);
			String date = rs.getString(5);
			String isActive = rs.getString(6);
			cm = new Message(id, sender, receiver, content, date, isActive);
			list.add(cm);
		}
		
		ps.close();
		con.close();
		return list;
	}
	
	 public void createMessage(Message ms) {
			Connection con = new DbConnection().getConnection();
			try {
			
				PreparedStatement pre = con.prepareStatement("INSERT INTO message(sender, receiver, content, date, isactive) values(?, ?, ?, ?, ?)");
				pre.setString(1, ms.getSender());
				pre.setString(2, ms.getReceiver());
				pre.setString(3, ms.getContent());
				pre.setString(4, ms.getDate());
				pre.setString(5, ms.getIsActive());
				pre.executeUpdate();
				
				pre.close();
				con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	
	public static void main(String[] args) throws SQLException {
		//System.out.println(new Gson().toJson(new MessageMod().getMessages("luanxt", "hahaha", 0, 8)));
		SimpleDateFormat da = new SimpleDateFormat("dd/MM/yy - hh:mm:ss");
		String d = da.format(new Date());
		System.out.println(d);
		
	}
}
